ON_HistoryRecord Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_object_history.h>`

Inheritance diagram for ON_HistoryRecord:

## Public Types

enum | RECORD_TYPE { history_parameters = 0, feature_parameters = 1, force_32bit_record_type = 0xFFFFFFFF }

## Public Member Functions

| ON_HistoryRecord ()
| ~ON_HistoryRecord ()
| ON_HistoryRecord (const ON_HistoryRecord &src)
ON_HistoryRecord & | operator= (const ON_HistoryRecord &src)
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &binary_archive) const
ON_BOOL32 | Read (ON_BinaryArchive &binary_archive)
ON_UUID | ModelObjectId () const
void | Destroy ()
void | DestroyValue (int value_id)
bool | SetBoolValue (int value_id, bool b)
bool | SetIntValue (int value_id, int i)
bool | SetDoubleValue (int value_id, double x)
bool | SetPointValue (int value_id, ON_3dPoint p)
bool | SetVectorValue (int value_id, ON_3dVector v)
bool | SetXformValue (int value_id, ON_Xform xform)
bool | SetColorValue (int value_id, ON_Color c)
bool | SetObjRefValue (int value_id, const ON_ObjRef &oref)
bool | SetPointOnObjectValue (int value_id, const ON_ObjRef &oref, ON_3dPoint point)
bool | SetUuidValue (int value_id, ON_UUID uuid)
bool | SetStringValue (int value_id, const wchar_t *s)
bool | SetGeometryValue (int value_id, ON_Geometry *g)
bool | SetPolyEdgeValue (int value_id, const ON_PolyEdgeHistory &polyedge)
bool | SetBoolValues (int value_id, int count, const bool *b)
bool | SetIntValues (int value_id, int count, const int *i)
bool | SetDoubleValues (int value_id, int count, const double *x)
bool | SetPointValues (int value_id, int count, const ON_3dPoint *P)
bool | SetVectorValues (int value_id, int count, const ON_3dVector *V)
bool | SetXformValues (int value_id, int count, const ON_Xform *xform)
bool | SetColorValues (int value_id, int count, const ON_Color *c)
bool | SetObjRefValues (int value_id, int count, const ON_ObjRef *oref)
bool | SetUuidValues (int value_id, int count, const ON_UUID *u)
bool | SetStringValues (int value_id, int count, const wchar_t *const *s)
bool | SetStringValues (int value_id, const ON_ClassArray< ON_wString > &s)
bool | SetGeometryValues (int value_id, const ON_SimpleArray< ON_Geometry * > a)
bool | SetPolyEdgeValues (int value_id, int count, const ON_PolyEdgeHistory *a)
bool | GetStringValue (int value_id, ON_wString &str) const
bool | GetBoolValue (int value_id, bool *b) const
bool | GetIntValue (int value_id, int *i) const
bool | GetDoubleValue (int value_id, double *number) const
bool | GetPointValue (int value_id, ON_3dPoint &point) const
bool | GetVectorValue (int value_id, ON_3dVector &point) const
bool | GetXformValue (int value_id, ON_Xform &point) const
bool | GetColorValue (int value_id, ON_Color *color) const
bool | GetObjRefValue (int value_id, ON_ObjRef &oref) const
bool | GetPointOnObjectValue (int value_id, ON_ObjRef &oref) const
bool | GetCurveValue (int value_id, const ON_Curve *&) const
bool | GetSurfaceValue (int value_id, const ON_Surface *&) const
bool | GetBrepValue (int value_id, const ON_Brep *&) const
bool | GetMeshValue (int value_id, const ON_Mesh *&) const
bool | GetGeometryValue (int value_id, const ON_Geometry *&) const
bool | GetUuidValue (int value_id, ON_UUID *uuid) const
bool | GetPolyEdgeValue (int value_id, const ON_PolyEdgeHistory *&polyedge) const
int | GetStringValues (int value_id, ON_ClassArray< ON_wString > &string) const
int | GetBoolValues (int value_id, ON_SimpleArray< bool > &) const
int | GetIntValues (int value_id, ON_SimpleArray< int > &) const
int | GetDoubleValues (int value_id, ON_SimpleArray< double > &) const
int | GetPointValues (int value_id, ON_SimpleArray< ON_3dPoint > &) const
int | GetVectorValues (int value_id, ON_SimpleArray< ON_3dVector > &) const
int | GetXformValues (int value_id, ON_SimpleArray< ON_Xform > &) const
int | GetColorValues (int value_id, ON_SimpleArray< ON_Color > &) const
int | GetObjRefValues (int value_id, ON_ClassArray< ON_ObjRef > &objects) const
int | GetGeometryValues (int value_id, ON_SimpleArray< const ON_Geometry * > &) const
int | GetUuidValues (int value_id, ON_SimpleArray< ON_UUID > &) const
int | GetPolyEdgeValues (int value_id, ON_SimpleArray< const ON_PolyEdgeHistory * > &) const
bool | IsAntecedent (ON_UUID object_uuid) const
int | ValueReport (ON_TextLog &text_log) const
void | RemapObjectIds (const ON_SimpleArray< ON_UuidPair > &uuid_remap)
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON::object_type | ObjectType () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Static Public Member Functions

static RECORD_TYPE | RecordType (int i)

## Public Attributes

ON_UUID | m_command_id
int | m_version
RECORD_TYPE | m_record_type
ON_UUID | m_record_id
ON_UuidList | m_antecedents
ON_UuidList | m_descendants
ON_SimpleArray< class ON_Value * > | m_value

## Detailed Description

Definition at line 83 of file opennurbs_object_history.h.

## Member Enumeration Documentation

enum ON_HistoryRecord::RECORD_TYPE

Enumerator
history_parameters |
feature_parameters |
force_32bit_record_type |

Definition at line 273 of file opennurbs_object_history.h.

## Constructor & Destructor Documentation

ON_HistoryRecord::ON_HistoryRecord | ( |  | ) |

ON_HistoryRecord::~ON_HistoryRecord | ( |  | ) |

ON_HistoryRecord::ON_HistoryRecord | ( | const ON_HistoryRecord & | src | ) |

## Member Function Documentation

void ON_HistoryRecord::Destroy | ( |  | ) |

void ON_HistoryRecord::DestroyValue | ( | int | value_id | ) |

void ON_HistoryRecord::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

bool ON_HistoryRecord::GetBoolValue | ( | int | value_id,
|  | bool * | b
| ) |  | const

int ON_HistoryRecord::GetBoolValues | ( | int | value_id,
|  | ON_SimpleArray< bool > & |
| ) |  | const

bool ON_HistoryRecord::GetBrepValue | ( | int | value_id,
|  | const ON_Brep *& |
| ) |  | const

bool ON_HistoryRecord::GetColorValue | ( | int | value_id,
|  | ON_Color * | color
| ) |  | const

int ON_HistoryRecord::GetColorValues | ( | int | value_id,
|  | ON_SimpleArray< ON_Color > & |
| ) |  | const

bool ON_HistoryRecord::GetCurveValue | ( | int | value_id,
|  | const ON_Curve *& |
| ) |  | const

bool ON_HistoryRecord::GetDoubleValue | ( | int | value_id,
|  | double * | number
| ) |  | const

int ON_HistoryRecord::GetDoubleValues | ( | int | value_id,
|  | ON_SimpleArray< double > & |
| ) |  | const

bool ON_HistoryRecord::GetGeometryValue | ( | int | value_id,
|  | const ON_Geometry *& |
| ) |  | const

int ON_HistoryRecord::GetGeometryValues | ( | int | value_id,
|  | ON_SimpleArray< const ON_Geometry * > & |
| ) |  | const

bool ON_HistoryRecord::GetIntValue | ( | int | value_id,
|  | int * | i
| ) |  | const

int ON_HistoryRecord::GetIntValues | ( | int | value_id,
|  | ON_SimpleArray< int > & |
| ) |  | const

bool ON_HistoryRecord::GetMeshValue | ( | int | value_id,
|  | const ON_Mesh *& |
| ) |  | const

bool ON_HistoryRecord::GetObjRefValue | ( | int | value_id,
|  | ON_ObjRef & | oref
| ) |  | const

int ON_HistoryRecord::GetObjRefValues | ( | int | value_id,
|  | ON_ClassArray< ON_ObjRef > & | objects
| ) |  | const

bool ON_HistoryRecord::GetPointOnObjectValue | ( | int | value_id,
|  | ON_ObjRef & | oref
| ) |  | const

bool ON_HistoryRecord::GetPointValue | ( | int | value_id,
|  | ON_3dPoint & | point
| ) |  | const

int ON_HistoryRecord::GetPointValues | ( | int | value_id,
|  | ON_SimpleArray< ON_3dPoint > & |
| ) |  | const

bool ON_HistoryRecord::GetPolyEdgeValue | ( | int | value_id,
|  | const ON_PolyEdgeHistory *& | polyedge
| ) |  | const

int ON_HistoryRecord::GetPolyEdgeValues | ( | int | value_id,
|  | ON_SimpleArray< const ON_PolyEdgeHistory * > & |
| ) |  | const

bool ON_HistoryRecord::GetStringValue | ( | int | value_id,
|  | ON_wString & | str
| ) |  | const

int ON_HistoryRecord::GetStringValues | ( | int | value_id,
|  | ON_ClassArray< ON_wString > & | string
| ) |  | const

bool ON_HistoryRecord::GetSurfaceValue | ( | int | value_id,
|  | const ON_Surface *& |
| ) |  | const

bool ON_HistoryRecord::GetUuidValue | ( | int | value_id,
|  | ON_UUID * | uuid
| ) |  | const

int ON_HistoryRecord::GetUuidValues | ( | int | value_id,
|  | ON_SimpleArray< ON_UUID > & |
| ) |  | const

bool ON_HistoryRecord::GetVectorValue | ( | int | value_id,
|  | ON_3dVector & | point
| ) |  | const

int ON_HistoryRecord::GetVectorValues | ( | int | value_id,
|  | ON_SimpleArray< ON_3dVector > & |
| ) |  | const

bool ON_HistoryRecord::GetXformValue | ( | int | value_id,
|  | ON_Xform & | point
| ) |  | const

int ON_HistoryRecord::GetXformValues | ( | int | value_id,
|  | ON_SimpleArray< ON_Xform > & |
| ) |  | const

bool ON_HistoryRecord::IsAntecedent | ( | ON_UUID | object_uuid | ) | const

ON_BOOL32 ON_HistoryRecord::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

ON_UUID ON_HistoryRecord::ModelObjectId | ( |  | ) | const

virtual

Reimplemented from ON_Object.

ON_HistoryRecord& ON_HistoryRecord::operator= | ( | const ON_HistoryRecord & | src | ) |

ON_BOOL32 ON_HistoryRecord::Read | ( | ON_BinaryArchive & | binary_archive | ) |

virtual

Reimplemented from ON_Object.

static RECORD_TYPE ON_HistoryRecord::RecordType | ( | int | i | ) |

static

void ON_HistoryRecord::RemapObjectIds | ( | const ON_SimpleArray< ON_UuidPair > & | uuid_remap | ) |

bool ON_HistoryRecord::SetBoolValue | ( | int | value_id,
|  | bool | b
| ) |  |

bool ON_HistoryRecord::SetBoolValues | ( | int | value_id,
|  | int | count,
|  | const bool * | b
| ) |  |

bool ON_HistoryRecord::SetColorValue | ( | int | value_id,
|  | ON_Color | c
| ) |  |

bool ON_HistoryRecord::SetColorValues | ( | int | value_id,
|  | int | count,
|  | const ON_Color * | c
| ) |  |

bool ON_HistoryRecord::SetDoubleValue | ( | int | value_id,
|  | double | x
| ) |  |

bool ON_HistoryRecord::SetDoubleValues | ( | int | value_id,
|  | int | count,
|  | const double * | x
| ) |  |

bool ON_HistoryRecord::SetGeometryValue | ( | int | value_id,
|  | ON_Geometry * | g
| ) |  |

bool ON_HistoryRecord::SetGeometryValues | ( | int | value_id,
|  | const ON_SimpleArray< ON_Geometry * > | a
| ) |  |

bool ON_HistoryRecord::SetIntValue | ( | int | value_id,
|  | int | i
| ) |  |

bool ON_HistoryRecord::SetIntValues | ( | int | value_id,
|  | int | count,
|  | const int * | i
| ) |  |

bool ON_HistoryRecord::SetObjRefValue | ( | int | value_id,
|  | const ON_ObjRef & | oref
| ) |  |

bool ON_HistoryRecord::SetObjRefValues | ( | int | value_id,
|  | int | count,
|  | const ON_ObjRef * | oref
| ) |  |

bool ON_HistoryRecord::SetPointOnObjectValue | ( | int | value_id,
|  | const ON_ObjRef & | oref,
|  | ON_3dPoint | point
| ) |  |

bool ON_HistoryRecord::SetPointValue | ( | int | value_id,
|  | ON_3dPoint | p
| ) |  |

bool ON_HistoryRecord::SetPointValues | ( | int | value_id,
|  | int | count,
|  | const ON_3dPoint * | P
| ) |  |

bool ON_HistoryRecord::SetPolyEdgeValue | ( | int | value_id,
|  | const ON_PolyEdgeHistory & | polyedge
| ) |  |

bool ON_HistoryRecord::SetPolyEdgeValues | ( | int | value_id,
|  | int | count,
|  | const ON_PolyEdgeHistory * | a
| ) |  |

bool ON_HistoryRecord::SetStringValue | ( | int | value_id,
|  | const wchar_t * | s
| ) |  |

bool ON_HistoryRecord::SetStringValues | ( | int | value_id,
|  | int | count,
|  | const wchar_t *const * | s
| ) |  |

bool ON_HistoryRecord::SetStringValues | ( | int | value_id,
|  | const ON_ClassArray< ON_wString > & | s
| ) |  |

bool ON_HistoryRecord::SetUuidValue | ( | int | value_id,
|  | ON_UUID | uuid
| ) |  |

bool ON_HistoryRecord::SetUuidValues | ( | int | value_id,
|  | int | count,
|  | const ON_UUID * | u
| ) |  |

bool ON_HistoryRecord::SetVectorValue | ( | int | value_id,
|  | ON_3dVector | v
| ) |  |

bool ON_HistoryRecord::SetVectorValues | ( | int | value_id,
|  | int | count,
|  | const ON_3dVector * | V
| ) |  |

bool ON_HistoryRecord::SetXformValue | ( | int | value_id,
|  | ON_Xform | xform
| ) |  |

bool ON_HistoryRecord::SetXformValues | ( | int | value_id,
|  | int | count,
|  | const ON_Xform * | xform
| ) |  |

int ON_HistoryRecord::ValueReport | ( | ON_TextLog & | text_log | ) | const

ON_BOOL32 ON_HistoryRecord::Write | ( | ON_BinaryArchive & | binary_archive | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

ON_UuidList ON_HistoryRecord::m_antecedents

Definition at line 300 of file opennurbs_object_history.h.

ON_UUID ON_HistoryRecord::m_command_id

Definition at line 265 of file opennurbs_object_history.h.

ON_UuidList ON_HistoryRecord::m_descendants

Definition at line 304 of file opennurbs_object_history.h.

ON_UUID ON_HistoryRecord::m_record_id

Definition at line 295 of file opennurbs_object_history.h.

RECORD_TYPE ON_HistoryRecord::m_record_type

Definition at line 280 of file opennurbs_object_history.h.

ON_SimpleArray< class ON_Value* > ON_HistoryRecord::m_value

Definition at line 308 of file opennurbs_object_history.h.

int ON_HistoryRecord::m_version

Definition at line 271 of file opennurbs_object_history.h.

The documentation for this class was generated from the following file:

- /build/pcl-6_P28C/pcl-1.7.2/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_object_history.h